﻿using Communication.Frames;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Communication
{
    public class DevicePolling
    {
        private SerialConnection serialConnection;

        private readonly object sync = new object();

        private RequestFrame getStatus;
        private RequestFrame setState;

        public DevicePolling(SerialConnection serialConnection)
        {
            this.serialConnection = serialConnection;
            getStatus = new RequestFrame(Command.GetDeviceState, 0);
        }

        public void Poll()
        {
            lock(sync)
            {
                RequestFrame frameToSend = getStatus;
                if (setState != null)
                    frameToSend = setState;

                // if command is sent, check if contains proper value
                if (frameToSend.Command == Command.SetLedState)
                    Debug.WriteLine(frameToSend.ToString());

                serialConnection.SendRequest(frameToSend);
                setState = null;
            }
        }

        public void SetLedState(bool on)
        {
            lock(sync)
            {
                byte value = (byte)(on ? 1 : 0);
                setState = new RequestFrame(Command.SetLedState, value);
            }
        }
    }
}
