﻿using Communication.Frames;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Communication
{
    public class RequestFormatter
    {
        public byte[] GetData(RequestFrame request)
        {
            byte[] data = new byte[RequestFrame.Length];
            data[0] = (byte)'#';
            data[RequestFrame.Length - 1] = (byte)'%';

            data[3] = (byte)'$';
            data[RequestFrame.Length - 4] = (byte)'$';

            string commandCode = CommandExtensions.GetCode(request.Command).Code;
            data[1] = (byte)commandCode[0];
            data[2] = (byte)commandCode[1];

            data[4] = request.Data;

            AddCrc(data);

            return data;
        }

        private void AddCrc(byte[] data)
        {
            data[data.Length - 3] = 0;
            data[data.Length - 2] = 0;

            ushort crc = CRC16.Get(data);
            data[data.Length - 3] = (byte)(crc >> 8);
            data[data.Length - 2] = (byte)crc;
        }
    }
}
