﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PC
{
    public static class FormExtensions
    {
        public static void UpdateUI(this Form form, Action action)
        {
            if (form.InvokeRequired)
            {
                form.Invoke((MethodInvoker)delegate { action(); });
            }
            else
                action();
        }

        public static void BeginUpdateUI(this Form form, Action action)
        {
            if (form.InvokeRequired)
            {
                form.BeginInvoke((MethodInvoker)delegate { action(); });
            }
            else
                action();
        }
    }
}
