﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Timers;

namespace PC
{
    public class RepeatingTask
    {
        private Action action;
        private Timer timer;

        public int ElapsedCount { get; private set; } = 0;

        public RepeatingTask()
        {
            timer = new Timer();
            timer.Elapsed += Timer_Elapsed;
        }

        private void Timer_Elapsed(object sender, ElapsedEventArgs e)
        {
            if (timer.Enabled)
            {
                ElapsedCount++;
                action?.Invoke();
            }
        }

        public void Start(Action action, TimeSpan interval)
        {
            if (timer.Enabled)
                return;

            this.action = action;
            ElapsedCount = 0;
            timer.Interval = interval.TotalMilliseconds;
            timer.Enabled = true;
        }

        public void Stop()
        {
            timer.Enabled = false;
        }
    }
}
